/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form;

import Helpers.FileHelper;
import Helpers.MessageHelper;
import common.constants;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Comparator;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import models.accountObj;
import models.classObj;
import models.enumObj;
import models.pointObj;
import models.studentObj;
import models.timetableObj;

/**
 *
 * @author HoiNT2
 */
public class frmQLTKB extends javax.swing.JFrame {

    accountObj acc = null;
    private static String filePath = "data/TKB17HCB.csv";
    private static String fileClassPath = "data/Class.csv";
    ArrayList<timetableObj> lstTkb = new ArrayList<>();
    ArrayList<classObj> lstClass = new ArrayList<>();

    /**
     * Creates new form frmQLTKB
     */
    public frmQLTKB() {
        initComponents();
        loadjTable(filePath);
        initClass();
    }

    public frmQLTKB(accountObj acc) {
        this.acc = acc;
        initComponents();
        loadjTable(filePath);
        initClass();
        if (this.acc.getGroupId() == 1) {
            btn_import.setEnabled(false);

        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jcbClass = new javax.swing.JComboBox();
        btn_import = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        table_tkb = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel5.setText("Lớp:");

        jcbClass.setName("cbxLop"); // NOI18N
        jcbClass.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcbClassActionPerformed(evt);
            }
        });

        btn_import.setText("Import file");
        btn_import.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_importActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        jLabel1.setText("Thời khoá biểu");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(245, 245, 245)
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 142, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(38, 38, 38)
                        .addComponent(jLabel5)
                        .addGap(32, 32, 32)
                        .addComponent(jcbClass, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(43, 43, 43)
                        .addComponent(btn_import, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(225, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 39, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jcbClass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5)
                    .addComponent(btn_import))
                .addContainerGap(20, Short.MAX_VALUE))
        );

        table_tkb.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "STT", "Mã Môn", "Tên Môn", "Phòng Học"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.Object.class, java.lang.Object.class, java.lang.Object.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jScrollPane2.setViewportView(table_tkb);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 622, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(32, 32, 32))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 216, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void initClass() {
        try {
            lstClass = FileHelper.readFileNew(classObj.class, fileClassPath, enumObj.classObj);
            if (lstClass != null && lstClass.size() > 0) {
                lstClass.stream().forEach((itemGroup) -> {
                    jcbClass.addItem(itemGroup);
                });
            }
            //TODO: Table sv
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    private void jcbClassActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcbClassActionPerformed
        // TODO add your handling code here:
        String text = jcbClass.getSelectedItem().toString();
        if (!text.equalsIgnoreCase("Chọn Lớp")) {
            filePath = "data/TKB" + text + ".csv";
            loadjTable(filePath);
        }
    }//GEN-LAST:event_jcbClassActionPerformed
    private void loadjTable(String fileName) {
        try {
            lstTkb = FileHelper.readFileNew(timetableObj.class, fileName, enumObj.timetableObj);
            if (lstTkb != null && lstTkb.size() > 0) {
                setTable(lstTkb);
            } else {
                setTable(new ArrayList<>());
            }
            //TODO: Table sv
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    private void setTable(ArrayList<timetableObj> lst) {
        try {
            if (lst == null) {
                JOptionPane.showMessageDialog(this, "Hệ thống bị lỗi không lấy đươc dữ liêu.");
                return;
            }
            DefaultTableModel tableModel = (DefaultTableModel) table_tkb.getModel();
            tableModel.setRowCount(0);
            lst.stream().forEach(x -> {
                tableModel.addRow(new Object[]{x.getId(), x.getCode(), x.getName(), x.getClassroom()});
            });
            table_tkb.setModel(tableModel);
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this, "Hệ thống bị lỗi không lấy đươc dữ liêu.");
        }
    }

    private int maxSTT() {
        if (lstTkb == null || lstTkb.size() == 0) {
            return -1;
        }
        return lstTkb.stream().max(Comparator.comparing(v -> v.Id)).get().getId();
    }
    private void btn_importActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_importActionPerformed
        // TODO add your handling code here:
        try {
            ArrayList<timetableObj> lstNew = FileHelper.readFileNew(timetableObj.class, "", enumObj.timetableObj);
            if (lstNew != null && lstNew.size() > 0) {
                int stt = maxSTT();
                if (stt == -1 || stt > 1) {
                    stt += 1;
                }

                
                if (lstTkb == null) {
                    lstTkb = new ArrayList<>();
                }
                if (MessageHelper.showConfirmDialog("Bạn có muốn ghi đè dữ liệu hay không")) {
                  
                    if (!lstTkb.isEmpty()) {
                        lstTkb = new ArrayList<>();
                    }
                    for (timetableObj item2 : lstNew) {
                        ArrayList<timetableObj> lstFlag = findByCode(item2.getCode());
                        if (lstFlag != null && lstFlag.size() > 0) {
                            for (timetableObj item : lstFlag) {
                                item.setClassroom(item2.getClassroom());
                                item.setName(item2.getName());
                            }
                        } else {
                            timetableObj objNew = new timetableObj(stt, item2.getCode(), item2.getName(), item2.getClassroom());
                            lstTkb.add(objNew);
                            stt += 1;
                            addStudentToSubject(objNew.getCode());
                        }
                    }
                } else {
                    for (timetableObj item2 : lstNew) {
                        timetableObj objNew = new timetableObj(stt, item2.getCode(), item2.getName(), item2.getClassroom());
                        lstTkb.add(objNew);
                        addStudentToSubject(objNew.getCode());
                        stt += 1;
                    }
                }
                try {
                    boolean result = FileHelper.writeFile(lstTkb, filePath, constants.TITLE_TimeTable);
                    if (result) {
                        setTable(lstTkb);
                        MessageHelper.Message("Import dữ liệu thành công");

                    } else {
                        MessageHelper.Message("Lỗi hệ thống.Xin vui lòng thử lại sau");
                    }
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            }
            //TODO: Table sv
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_btn_importActionPerformed
    public ArrayList<timetableObj> findByCode(String code) {
        ArrayList<timetableObj> arr = new ArrayList<>();
        for (timetableObj item : lstTkb) {
            if (item.getCode().equals(code)) {
                arr.add(item);
            }
        }
        int size = arr.size();
        if (size > 0) {
            return arr;
        }
        return null;
    }

   
    public void addStudentToSubject(String codeCourse) {
        try {
            String textClass = jcbClass.getSelectedItem().toString();
            if (!textClass.equalsIgnoreCase("Chọn Lớp")) {
                String filePathSV = "data/" + textClass + ".csv";
                ArrayList<studentObj> lstSv = FileHelper.readFileNew(studentObj.class, filePathSV, enumObj.studentOb);

                String filePathPoint = "data/" + textClass + "-" + codeCourse + ".csv";
                ArrayList<pointObj> lstPoint = FileHelper.readFileNew(pointObj.class, filePathPoint, enumObj.pointObj);
                int stt = 1;
                // TODO: Nếu file đó có sinh viên rồi thì sẽ cập nhật dữ liệu
                if (lstPoint != null && !lstPoint.isEmpty()) {
                    stt = lstPoint.get(lstPoint.size()).getId() + 1;
                } else {
                    lstPoint = new ArrayList<>();
                }
                if (lstSv != null) {
                    for (studentObj sv : lstSv) {
                        // TODO:
                        if (lstPoint != null && !lstPoint.isEmpty()
                                && lstPoint.stream().filter(m -> m.getCode().equals(sv.getMSSV())).count() > 0) {
                            continue;
                        }
                        pointObj stu = new pointObj(stt, sv.getMSSV(), sv.getHoTen(), 0, 0, 0, 0);
                        lstPoint.add(stu);
                        stt += 1;
                    }
                }
                boolean result = FileHelper.writeFile(lstPoint, filePathPoint, constants.TITLE_POINT);
            }

        } catch (IOException e) {

        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(frmQLTKB.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(frmQLTKB.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(frmQLTKB.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(frmQLTKB.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new frmQLTKB().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_import;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JComboBox jcbClass;
    private javax.swing.JTable table_tkb;
    // End of variables declaration//GEN-END:variables
}
